;**************************************************************************
;*                                                                        *
;* Title:               Zirkulationssensor  www.icplan.de                 *
;* File:                ZIRKU.ASM                                         *
;* Autor:               Jens Dietrich - Hoyerswerda - Germany             *
;* Version:             1.00                                              *
;* Startet:             12.09.2010                                        *
;* Last updated:        17.09.2010                                        *
;* Target:              ATTINY2313                                        *
;* Support E-mail:      jd@icplan.de                                      *
;*                                                                        *
;**************************************************************************
;
;  Port B  0 OUT LED rot
;          1 IN  Signal vom Bewegungssensor H-aktiv
;          2 OUT Funkmodul einschalten
;          3 OUT Funksignal ein
;

.include "tn2313def.inc"

.cseg

.org 0

rjmp	reset

reset:	

ldi	r16,(RAMEND)		;Stack	
out	SPL,r16
;
clr	r16
out	portb,r16
ldi	r16,0b00001101		;bit1=output
out	ddrb,r16
;
ldi	r16,40				;kurze pause
rcall	lcd_zeit1

sbi portb,0				;led ein
ldi	r16,4
rcall	lcd_zeit1
cbi portb,0				;led aus
ldi	r16,8
rcall	lcd_zeit1

sbi portb,0				;led ein
ldi	r16,4
rcall	lcd_zeit1
cbi portb,0				;led aus
ldi	r16,8
rcall	lcd_zeit1

sbi portb,0				;led ein
ldi	r16,4
rcall	lcd_zeit1
cbi portb,0				;led aus
ldi	r16,8
rcall	lcd_zeit1

;**************************************************************************
;* Programmteil                                                           *
;**************************************************************************

zir:
in r16,pinb
andi r16,0x02
breq zir
sbi portb,0				;led ein
rcall	senden
ldi	r16,40
rcall	lcd_zeit1
cbi portb,0				;led aus
rjmp zir

;**************************************************************************
;* Senden 100 mal 1,5ms high und 1,5ms low                                 *
;**************************************************************************

senden:
ldi	r16,100
sbi portb,2				;funkmodul einschalten
rcall	sen10
senden1:
sbi	portb,3
rcall	sen10
cbi	portb,3
rcall	sen10
dec	r16
brne	senden1
cbi	portb,2				;funkmodul ausschalten
ret
;
sen10:					;zeitschleife 10ms
ldi r17,15
clr r18
sen11:
dec	r18
brne	sen11
dec	r17
brne	sen11
ret

;**************************************************************************
;* Zeitschleife (r16 = 4 = 100ms)                                         *
;**************************************************************************

lcd_zeit:
ldi	r16,30
lcd_zeit1:
push	r16
ldi	r16,0
lcd_zeit2:
push	r16
ldi	r16,0
lcd_zeit3:
dec	r16
brne	lcd_zeit3
pop	r16
dec	r16
brne	lcd_zeit2
pop	r16
dec	r16
brne	lcd_zeit1
ret

.exit
